<template>
    <div class="modal_wrapper" ref="modalWrapper">
        <transition name="modalAnimation" appear mode="out-in">
            <access-form v-if="currentModal === 'accessForm'"
                         @formClosedEvent="onClosedEvent"
                         @switchToSuccessModal="onSwitchToAnotherModal('successModal')"
                         class="true_access_form"
            >{{ local.getDemoAccess[$lang] }}</access-form>
            <DiscountProgramm v-if="currentModal === 'discountProgramm'"
                               @discountProgrammClosedEvent="onClosedEvent"
            ></DiscountProgramm>
            <coalition-program v-if="currentModal === 'coalitionProgram'"
                              @discountProgrammClosedEvent="onClosedEvent"
            ></coalition-program>
            <individual-program v-if="currentModal === 'individualProgram'"
                               @discountProgrammClosedEvent="onClosedEvent"
            ></individual-program>
            <internet-program v-if="currentModal === 'internetProgram'"
                                @discountProgrammClosedEvent="onClosedEvent"
            ></internet-program>
            <login-form v-if="currentModal === 'loginForm'"
                        @formClosedEvent="onClosedEvent"
                        @switchToAccessForm="onSwitchToAnotherModal('accessForm')"
            ></login-form>
            <success-modal v-if="currentModal === 'successModal'"
                           @formClosedEvent="onClosedEvent"
                           @discountProgrammClosedEvent="onClosedEvent"
            ></success-modal>
        </transition>
    </div>
</template>

<script>
    import AccessForm from './AccessForm.vue'
    import DiscountProgramm from './DiscountProgramm.vue'
    import CoalitionProgram from './CoalitionProgram.vue'
    import InternetProgram from './InternetProgram.vue'
    import IndividualProgram from './IndividualProgram.vue'
    import LoginForm from './LoginForm.vue'
    import SuccessModal from './SuccessModal.vue'
    import local from '../../localisation/modals/modalWrapperLocalisaton.js';

    export default {
        data: ()=>({
           local
        }),
        props: {
            currentModal: {
                type: String
            }
        },
        components: {
            AccessForm,
            DiscountProgramm,
            CoalitionProgram,
            IndividualProgram,
            InternetProgram,
            LoginForm,
            SuccessModal
        },
        methods: {
            onClosedEvent() {
                this.$emit('modalClosedEvent')
            },
            onSwitchToAnotherModal(name) {
                this.$emit('switchPopup', name)
            }
        },
    }
</script>

<style lang="scss" scoped>
    .modalAnimation-enter {
        transform: translate3d(0,-30px,0);
        opacity: 0;
    }
    .modalAnimation-enter-active {
        transition: all 0.3s;
    }
    .modalAnimation-leave-active {
        transform: translate3d(0,-30px,0);
        opacity: 0;
        transition: all 0.3s;
    }
   .modal_wrapper {
       height: 100vh;
       width: 100%;
       position: fixed;
       left: 0;
       top: 0;
       background-color: rgba(0,0,0,0.4);
       z-index: 100;
       display: flex;
       align-items: center;
       justify-content: center;
   }
</style>
